/*
*  Rubrica
*  file: 
*
*  
*  Copyright (C) 2000-2005 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gtk/gtk.h>
#include <libral.h>

#include "adb.h"
#include "gui_types.h"


#ifndef RUBRICA_APP_H
#define RUBRICA_APP_H

#define RUBRICA_APP_TYPE           (rubrica_app_get_type())

#define RUBRICA_APP(obj)           (G_TYPE_CHECK_INSTANCE_CAST((obj),     \
                                    RUBRICA_APP_TYPE, RubricaApp))

#define RUBRICA_APP_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST((klass),      \
                                    RUBRICA_APP_TYPE, RubricaAppClass))

#define IS_RUBRICA_APP(obj)        (G_TYPE_CHECK_INSTANCE_TYPE((obj),     \
                                    RUBRICA_APP_TYPE))

#define IS_RUBRICA_APP_CLASS(kls)  (G_TYPE_CHECK_CLASS_TYPE((kls),        \
                                    RUBRICA_APP_TYPE))

#define RUBRICA_APP_GET_CLASS(kls) (G_TYPE_INSTANCE_GET_CLASS((kls),      \
			            RUBRICA_APP_TYPE, RubricaAppClass))


typedef struct _RubricaApp        RubricaApp; 
typedef struct _RubricaAppClass   RubricaAppClass;
typedef struct _RubricaAppPrivate RubricaAppPrivate;


struct _RubricaApp {
  GObject parent;
   
  RubricaAppPrivate* private;  
};


struct _RubricaAppClass {
  GObjectClass parent;

  /*     Signals
  */
  //  void (*renamed) (RubricaApp* app, gchar* newname);
};



GType            rubrica_app_get_type (void);


RubricaApp*      rubrica_app_new  (void);
void             rubrica_app_free (RubricaApp* app);

void             rubrica_app_init_trash             (RubricaApp* app);
void             rubrica_app_run                    (RubricaApp* app);

GtkWidget*       rubrica_app_get_main_window        (RubricaApp* app);
RubricaAdb*      rubrica_app_get_active_addressbook (RubricaApp* app);
RubricaGroupSet* rubrica_app_get_active_user_groups (RubricaApp* app);
RubricaGroupSet* rubrica_app_get_groups             (RubricaApp* app);

GtkWidget*       rubrica_app_get_textview           (RubricaApp* app);
GtkWidget*       rubrica_app_get_groupstree         (RubricaApp* app);
GtkWidget*       rubrica_app_get_bookstree          (RubricaApp* app);
gint             rubrica_app_get_stack_len          (RubricaApp* app);


void             rubrica_app_set_active_addressbook (RubricaApp* app, 
						     RubricaAdb* adb);

void             rubrica_app_enable_lock_pixmap     (RubricaApp* app, 
						     RubricaLockPixmap lock);
void             rubrica_app_enable_rank_pixmap     (RubricaApp* app, 
						     RubricaRank rank);

void             rubrica_app_show_page              (RubricaApp* app, 
						     gint page);

void             rubrica_app_append_addressbook     (RubricaApp* app, 
						     RubricaAdb* adb);
void             rubrica_app_add_card_to_view       (RubricaApp* app,
						     RubricaCard* card);

void             rubrica_app_move_card_to_trash     (RubricaApp* app,
						     RubricaCard* card);

void             rubrica_app_push                   (RubricaApp* app,
						     gpointer data);
gpointer         rubrica_app_pop                    (RubricaApp* app);
void             rubrica_app_notify                 (RubricaApp* app, 
						     gchar* msg);

void             rubrica_app_update_cards_view_on_delete (RubricaApp* app);
void             rubrica_app_update_cards_view_on_cut    (RubricaApp* app);
void             rubrica_app_update_cards_view_on_paste  (RubricaApp* app);

void             rubrica_app_update_bookstree_view       (RubricaApp* app);


#endif
