/*
*  Rubrica
*  file: popmenu.c
*
*  
*  Copyright (C) 2000-2005 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#include <gtk/gtk.h>
#include <glade/glade.h>

#include "app.h"
#include "callbacks.h"
#include "types.h"


GtkMenu* 
rubrica_menu_do_card_popup(RubricaApp* app, GtkTreeView* tree, GdkEvent *event)
{  
  GladeXML* gui;
  GdkEventButton *ev = (GdkEventButton *)event;
  GtkTreeModel *model;
  GtkTreeSelection *selection; 
  GtkTreePath *path = NULL;
  GtkMenu* menu;  
  GtkWidget* cut;
  GtkWidget* copy;
  GtkWidget* paste;
  GtkWidget* modify;
  GtkWidget* delete;
  GtkWidget* item;

  gui       = glade_xml_new (RUBRICA_GUI_DIR"/Menu.glade", NULL, NULL);    
  model     = gtk_tree_view_get_model(GTK_TREE_VIEW(tree));
  selection = gtk_tree_view_get_selection(tree);

  menu = (GtkMenu*) glade_xml_get_widget(gui, "menu1");  

  cut = glade_xml_get_widget(gui, "cut");
  g_signal_connect(G_OBJECT(cut), "activate", 
		   G_CALLBACK(on_cut_cb), app);
  
  copy = glade_xml_get_widget(gui, "copy");
  g_signal_connect(G_OBJECT(copy), "activate", 
		   G_CALLBACK(on_copy_cb), app);
  
  paste = glade_xml_get_widget(gui, "paste");
  g_signal_connect(G_OBJECT(paste), "activate", 
		   G_CALLBACK(on_paste_cb), app);
  
  item = glade_xml_get_widget(gui, "add_personal");
  g_signal_connect(G_OBJECT(item), "activate", 
		   G_CALLBACK(on_add_personal_cb), app);
  
  item = glade_xml_get_widget(gui, "add_company");
  g_signal_connect(G_OBJECT(item), "activate", 
		   G_CALLBACK(on_add_company_cb), app);
  
  modify = glade_xml_get_widget(gui, "modify_card");
  g_signal_connect(G_OBJECT(modify), "activate", 
		   G_CALLBACK(on_modify_card_cb), app);
  
  delete = glade_xml_get_widget(gui, "delete_card");
  g_signal_connect(G_OBJECT(delete), "activate", 
		   G_CALLBACK(on_delete_card_cb), app);
  
  /*  item = glade_xml_get_widget(gui, "");
      g_signal_connect(G_OBJECT(), "activate", 
		       G_CALLBACK(), app);
  */
 
  if (!gtk_tree_view_get_path_at_pos(tree, ev->x, ev->y, &path, NULL,
				     NULL, NULL))
    {
      gtk_widget_set_sensitive(cut, FALSE);
      gtk_widget_set_sensitive(copy, FALSE);
      
      if (!rubrica_app_get_stack_len(app))
	gtk_widget_set_sensitive(paste, FALSE);
      gtk_widget_set_sensitive(modify, FALSE);
      gtk_widget_set_sensitive(delete, FALSE);

    }
  
  return menu;
}
