/*
*  Rubrica
*  file: 
*
*  
*  Copyright (C) 2000-2005 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gtk/gtk.h>
#include <glade/glade.h>

#ifndef _TYPES_
#define _TYPES_

#define RUBRICA_GET_ENTRY(x) g_strdup(gtk_entry_get_text(GTK_ENTRY(x)))
#define RUBRICA_GET_CHECK(x) gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x))





typedef struct {
  gchar* filter_name;
  gchar* filter_pattern;
} RubricaFilterType;


typedef enum {
  CARD_COLUMN,
  FIRST_NAME_COLUMN,
  LAST_NAME_COLUMN,
  PROFESSION_COLUMN,
  CITY_COLUMN,
  COUNTRY_COLUMN,
  WEB_CARD_COLUMN,
  EMAIL_CARD_COLUMN,
  TELEPHONE_COLUMN,
  COMPANY_COLUMN,
  ASSIGMENT_COLUMN,
  ID_COLUMN,
  COLUMNS
} PersonalCardColumns;


typedef enum {
  ADDRESSBOOK_MODEL = 0,
  CARDS_MODEL,
  GROUP_MODEL,
  ADDRESS_MODEL,
  NET_MODEL,
  TELEPHONE_MODEL
} RubricaModelType;


typedef enum {
  ADDRESSBOOK_COLUMNS = 0,
  CARDS_COLUMNS,
  GROUP_COLUMNS,
  APP_GROUP_COLUMNS,
  ADDRESS_COLUMNS,
  URI_COLUMNS,  
  TELEPHONE_COLUMNS
} RubricaColumnsType;


typedef enum {
  GROUP_BELONG_COLUMN = 0,       // card belongs to this group
  GROUP_PIXMAP_COLUMN,           // group pixmap
  GROUP_LABEL_COLUMN,            // group pixmap 
  GROUP_OWNER_COLUMN,            // group owner (hidden column) 
  GROUP_PIXMAP_PATH,             // group pixmap's path
  GROUP_LAST_COLUMN               
} RubricaGroupColumnType;


/* colums in Addressbook model/treeview */
typedef enum {
  ADDRESSBOOK_PIXMAP_COLUMN,        // red/green pixmap (changed/unchanged)
  ADDRESSBOOK_FILENAME_COLUMN,      // addressbook's name  
  ADDRESSBOOK_PAGE_COLUMN,          // addressbook's id
  ADDRESSBOOK_LAST_COLUMN
} RubricaAddressBookColumnType;


/* columns in address model/treeview */
typedef enum {
  ADDRESS_STREET_COLUMN = 0,    // visible
  ADDRESS_NUMBER_COLUMN,        // visible
  ADDRESS_CITY_COLUMN,          // visible
  ADDRESS_TYPE_COLUMN,          // visible
  ADDRESS_ZIP_COLUMN,           // hidden
  ADDRESS_PROVINCE_COLUMN,      // hidden
  ADDRESS_STATE_COLUMN,         // hidden
  ADDRESS_COUNTRY_COLUMN,       // hidden
  LAST_ADDRESS_COLUMN
} RubricaAddressColumnType;


/* colums in net model/treeview */
typedef enum {
  URI_COLUMN = 0,
  URI_TYPE_COLUMN,
  LAST_NET_COLUMN
} RubricaNetColumnType;


/* columns in telephone model/treeview */
typedef enum {
  TELEPHONE_NUMBER_COLUMN = 0,
  TELEPHONE_TYPE_COLUMN,
  LAST_TEL_COLUMN
} RubricaPhoneColumnType;



/*
typedef struct  {
  gchar* pixmap;
  gchar* label;

  gint type;
} RubricaOptionType;
*/


typedef enum {
  NO_GROUP         = 0,
  ALL_GROUP,
  FAVORITES_GROUP,
  HOT_GROUP,
  FRIENDS_GROUP,
  HEART_GROUP, 
  RELATIVES_GROUP,
  HOLIDAYS_GROUP,
  HOBBIES_GROUP,
  SPORT_GROUP,
  BUSSINES_GROUP,
  COMPANY_GROUP,
  WORK_GROUP,
  CUSTOMER_GROUP,
  STRATEGIES_GROUP,
  PROGRAMMERS_GROUP,
  BSD_GROUP,
  PLUTO_GROUP
} RubricaGroupType;

/*
typedef enum  {
  TELEPHONE_HOME = 0,
  TELEPHONE_WORK,
  TELEPHONE_FAX,
  TELEPHONE_CELLPHONE,
  TELEPHONE_OTHER,
  TELEPHONE_UNKNOWN
} RubricaTelephoneType;
*/





#endif
